// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Restructure.pas' rev: 3.00

#ifndef RestructureHPP
#define RestructureHPP
#include <ShellAPI.hpp>
#include <DBTables.hpp>
#include <Bde.hpp>
#include <Db.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Restructure
{
//-- type declarations -------------------------------------------------------
enum TdBasePxFieldType { pxUnknown, pxAlpha, pxNumber, pxMoney, pxShort, pxLongInteger, pxBCD, pxDate, 
	pxTime, pxTimestamp, pxMemo, pxFormattedMemo, pxGraphic, pxOLE, pxLogical, pxAutoincrement, pxBinary, 
	pxBytes, dbCharacter, dbFloat, dbNumber, dbDate, dbMemo, dbLogical, dbOLE, dbBinary, dbLong, dbDateTime, 
	dbDouble, dbAutoincrement, dbBytes, dbLock };

enum TFieldRights { frReadWrite, frReadOnly, frNone, frUnknown };

enum TTableRights { trNone, trReadOnly, trModify, trInsert, trInsDel, trFull, trUnknown };

class DELPHICLASS TFieldDesc;
class PASCALIMPLEMENTATION TFieldDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FName;
	TdBasePxFieldType FFieldType;
	Word FLength;
	Word FPrecision;
	void __fastcall SetName(System::AnsiString Value);
	void __fastcall SetFieldType(TdBasePxFieldType Value);
	void __fastcall SetLength(Word Value);
	void __fastcall SetPrecision(Word Value);
	
public:
	__fastcall virtual TFieldDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::AnsiString Name = {read=FName, write=SetName};
	__property TdBasePxFieldType FieldType = {read=FFieldType, write=SetFieldType, nodefault};
	__property Word Length = {read=FLength, write=SetLength, nodefault};
	__property Word Precision = {read=FPrecision, write=SetPrecision, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TFieldDesc(void) { }
	
};

enum TLookupType { ltCurrentField, ltAllCorresponding };

enum TLookupAccess { laFillNoHelp, laHelpAndFill };

class DELPHICLASS TValCheckDesc;
class PASCALIMPLEMENTATION TValCheckDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Dbtables::TTable* Table;
	bool FRequired;
	System::AnsiString FMinimumValue;
	System::AnsiString FMaximumValue;
	System::AnsiString FDefaultValue;
	System::AnsiString FPicture;
	System::AnsiString FLookupDatabaseName;
	System::AnsiString FLookupTableName;
	TLookupType FLookupType;
	TLookupAccess FLookupAccess;
	void __fastcall SetRequired(bool Value);
	void __fastcall SetMinimumValue(System::AnsiString Value);
	void __fastcall SetMaximumValue(System::AnsiString Value);
	void __fastcall SetDefaultValue(System::AnsiString Value);
	void __fastcall SetPicture(System::AnsiString Value);
	void __fastcall SetLookupDatabaseName(System::AnsiString Value);
	void __fastcall SetLookupTableName(System::AnsiString Value);
	void __fastcall SetLookupType(TLookupType Value);
	void __fastcall SetLookupAccess(TLookupAccess Value);
	
public:
	__fastcall virtual TValCheckDesc(void);
	__fastcall virtual ~TValCheckDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Required = {read=FRequired, write=SetRequired, nodefault};
	__property System::AnsiString MinimumValue = {read=FMinimumValue, write=SetMinimumValue};
	__property System::AnsiString MaximumValue = {read=FMaximumValue, write=SetMaximumValue};
	__property System::AnsiString DefaultValue = {read=FDefaultValue, write=SetDefaultValue};
	__property System::AnsiString Picture = {read=FPicture, write=SetPicture};
	__property System::AnsiString LookupDatabaseName = {read=FLookupDatabaseName, write=SetLookupDatabaseName
		};
	__property System::AnsiString LookupTableName = {read=FLookupTableName, write=SetLookupTableName};
	__property TLookupType LookupType = {read=FLookupType, write=SetLookupType, nodefault};
	__property TLookupAccess LookupAccess = {read=FLookupAccess, write=SetLookupAccess, nodefault};
};

enum TUpdateRule { urCascade, urRestrict };

class DELPHICLASS TRefIntDesc;
class PASCALIMPLEMENTATION TRefIntDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Dbtables::TTable* Table;
	System::AnsiString FMasterDatabaseName;
	System::AnsiString FMasterTableName;
	TUpdateRule FModifyOperation;
	TUpdateRule FDeleteOperation;
	void __fastcall SetMasterTableName(System::AnsiString Value);
	void __fastcall SetModifyOperation(TUpdateRule Value);
	void __fastcall SetDeleteOperation(TUpdateRule Value);
	
public:
	__fastcall virtual TRefIntDesc(void);
	__fastcall virtual ~TRefIntDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::AnsiString MasterDatabaseName = {read=FMasterDatabaseName};
	__property System::AnsiString MasterTableName = {read=FMasterTableName, write=SetMasterTableName};
	__property TUpdateRule ModifyOperation = {read=FModifyOperation, write=SetModifyOperation, nodefault
		};
	__property TUpdateRule DeleteOperation = {read=FDeleteOperation, write=SetDeleteOperation, nodefault
		};
};

typedef void __fastcall (__closure *TFieldInappropriateEvent)(System::TObject* Sender, const TFieldDesc* 
	AField);

class DELPHICLASS TRestructure;
class PASCALIMPLEMENTATION TRestructure : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Dbtables::TTable* Table;
	System::AnsiString FDatabaseName;
	System::AnsiString FTableName;
	TFieldDesc* FField;
	TValCheckDesc* FValCheck;
	TRefIntDesc* FRefInt;
	System::AnsiString FPassword;
	bool FPackTable;
	Word FPrimaryIndexFieldCount;
	bool lHadPrimaryIndex;
	TFieldInappropriateEvent FOnFieldInappropriate;
	void __fastcall SetDatabaseName(System::AnsiString Value);
	void __fastcall SetTableName(System::AnsiString Value);
	void __fastcall SetField(TFieldDesc* Value);
	void __fastcall SetValCheck(TValCheckDesc* Value);
	void __fastcall SetRefInt(TRefIntDesc* Value);
	void __fastcall SetPackTable(bool Value);
	void __fastcall SetPrimaryIndexFieldCount(Word Value);
	
protected:
	Bde::FLDDesc *Fields;
	Bde::CROpType *FieldOperations;
	Bde::VCHKDesc *ValChecks;
	Bde::CROpType *ValCheckOperations;
	Bde::RINTDesc *RefInts;
	Bde::CROpType *RefIntOperations;
	Bde::IDXDesc *Indexes;
	Bde::CROpType *IndexOperations;
	Bde::SECDesc *SecDescs;
	Bde::CROpType *SecDescOperations;
	bool IsProtected;
	void __fastcall CreateFieldDescs(void);
	void __fastcall LoadFieldDescs(void);
	void __fastcall CreateAndLoadFieldDescs(void);
	void __fastcall DestroyFieldDescs(void);
	virtual void __fastcall SetFieldType(Bde::pFLDDesc AField, TdBasePxFieldType AType);
	virtual bool __fastcall FieldAppropriate(void);
	TdBasePxFieldType __fastcall GetFieldType(System::AnsiString FldName);
	Word __fastcall GetFieldPrecision(System::AnsiString FldName);
	void __fastcall MoveValChecksInsert(int Position);
	void __fastcall MoveValChecksMove(int OldPos, int NewPos);
	void __fastcall MoveValChecksDrop(int Position);
	bool __fastcall ValCheckToAdd(System::AnsiString FldName);
	Bde::pFLDDesc __fastcall GetField(System::AnsiString FldName);
	int __fastcall GetFieldPos(System::AnsiString FldName);
	int __fastcall GetValCheckPos(System::AnsiString FldName);
	int __fastcall GetRefIntPos(System::AnsiString RIName);
	Word __fastcall SetMinMaxDefValue(System::AnsiString Value, TdBasePxFieldType FldType, Word FldPrec
		, Byte * NewValCheck);
	System::AnsiString __fastcall GetMinMaxDefValue(TdBasePxFieldType FldType, Word FldPrec, const Byte 
		* AValCheck);
	Word __fastcall LogicalToPhysical(TdBasePxFieldType AFieldType);
	TdBasePxFieldType __fastcall PhysicalToLogical(Word AFieldType);
	
public:
	System::AnsiString TableType;
	Word TableLevel;
	int FieldCount;
	int ValCheckCount;
	int RefIntCount;
	int IndexCount;
	int SecDescCount;
	__fastcall virtual TRestructure(Classes::TComponent* AOwner);
	__fastcall virtual ~TRestructure(void);
	void __fastcall GetFieldDesc(int Position);
	virtual int __fastcall FieldByName(System::AnsiString FldName);
	virtual void __fastcall AddField(bool lAddValChecks);
	virtual void __fastcall InsertField(int Position, bool lAddValChecks);
	virtual void __fastcall MoveField(int OldPos, int NewPos);
	virtual void __fastcall DropField(int Position);
	virtual void __fastcall ChangeField(int Position, bool lChangeValChecks);
	bool __fastcall HasValChecks(System::AnsiString FldName);
	virtual void __fastcall AddValCheck(System::AnsiString FldName);
	virtual void __fastcall ChangeValCheck(System::AnsiString FldName);
	virtual void __fastcall DropValCheck(System::AnsiString FldName);
	bool __fastcall HasRefInts(void);
	virtual void __fastcall AddRefInt(System::AnsiString RIName, System::AnsiString DetIdx);
	virtual void __fastcall DropRefInt(System::AnsiString RIName);
	void __fastcall AddMasterPassword(System::AnsiString Password);
	void __fastcall ChangeMasterPassword(System::AnsiString Password);
	void __fastcall DropMasterPassword(void);
	void __fastcall AddAuxPassword(System::AnsiString AuxPassword, TTableRights TableRights);
	void __fastcall ChangeAuxPassword(System::AnsiString OldAuxPassword, System::AnsiString NewAuxPassword
		, TTableRights TableRights);
	void __fastcall DropAuxPassword(System::AnsiString AuxPassword);
	void __fastcall ChangeFieldRights(System::AnsiString AuxPassword, System::AnsiString FieldName, TFieldRights 
		Rights);
	void __fastcall Cancel(void);
	void __fastcall Apply(void);
	void __fastcall SortValChecks(void);
	
__published:
	__property TFieldDesc* Field = {read=FField, write=SetField};
	__property TValCheckDesc* ValCheck = {read=FValCheck, write=SetValCheck};
	__property System::AnsiString DatabaseName = {read=FDatabaseName, write=SetDatabaseName};
	__property System::AnsiString TableName = {read=FTableName, write=SetTableName};
	__property bool PackTable = {read=FPackTable, write=SetPackTable, nodefault};
	__property TRefIntDesc* RefInt = {read=FRefInt, write=SetRefInt};
	__property Word PrimaryIndexFieldCount = {read=FPrimaryIndexFieldCount, write=SetPrimaryIndexFieldCount
		, nodefault};
	__property TFieldInappropriateEvent OnFieldInappropriate = {read=FOnFieldInappropriate, write=FOnFieldInappropriate
		};
};

//-- var, const, procedure ---------------------------------------------------
#define RestrMaxNumOfTypes (Byte)(31)
extern PACKAGE Word RestrPhysicalTypes[31];
extern PACKAGE TdBasePxFieldType RestrLogicalTypes[31];

}	/* namespace Restructure */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Restructure;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Restructure
